commit a9e07e1651a4a219602ef848fa891ba78733084f
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Thu Aug 12 20:56:14 2021

    libstdc++: Install GDB pretty printers for debug library
    
    The additional libraries installed by --enable-libstdcxx-debug are built
    without optimization to aid debugging, but the Python pretty printers
    are not installed alongside them. This means that you can step through
    the unoptimized library code, but at the expense of pretty printing the
    library types.
    
    This remedies the situation by installing another copy of the GDB hooks
    alongside the debug version of libstdc++.so.
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            * python/Makefile.am [GLIBCXX_BUILD_DEBUG] (install-data-local):
            Install another copy of the GDB hook.
            * python/Makefile.in: Regenerate.
    
    (cherry picked from commit db853ff78a34fef25bc16133e0367a64526f9f4e)

diff --git a/libstdc++-v3/python/Makefile.am b/libstdc++-v3/python/Makefile.am
index 8efefa5725c..bc4a26651d8 100644
--- a/libstdc++-v3/python/Makefile.am
+++ b/libstdc++-v3/python/Makefile.am
@@ -29,6 +29,12 @@ else
 pythondir = $(datadir)/gcc-$(gcc_version)/python
 endif
 
+if GLIBCXX_BUILD_DEBUG
+debug_gdb_py = YES
+else
+debug_gdb_py =
+endif
+
 all-local: gdb.py
 
 nobase_python_DATA = \
@@ -53,4 +59,8 @@ install-data-local: gdb.py
 		  $(DESTDIR)$(toolexeclibdir)/libstdc++.la`; \
 	fi; \
 	echo " $(INSTALL_DATA) gdb.py $(DESTDIR)$(toolexeclibdir)/$$libname-gdb.py"; \
-	$(INSTALL_DATA) gdb.py $(DESTDIR)$(toolexeclibdir)/$$libname-gdb.py
+	$(INSTALL_DATA) gdb.py $(DESTDIR)$(toolexeclibdir)/$$libname-gdb.py ; \
+	if [ -n "$(debug_gdb_py)" ]; then \
+	  sed "/^libdir = /s;'$$;/debug';" gdb.py > debug-gdb.py ; \
+	  $(INSTALL_DATA) debug-gdb.py $(DESTDIR)$(toolexeclibdir)/debug/$$libname-gdb.py ; \
+	fi
